		
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.arena
	
	LoadAddOn("Blizzard_ArenaUI") -- You only need to run this once. You can safely delete any copies of this line.

	for i = 1, 5 do
		local f = _G["ArenaEnemyFrame"..i], _G["ArenaPrepFrame"..i]
		local p = _G["ArenaEnemyFrame"..i.."PetFrame"] 
		f:ClearAllPoints()
		f:SetParent(UIParent)
		f:SetScale(cfg.scale)
		if i == 1 then
			f:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		else
			local previous = _G["ArenaEnemyFrame"..i-1], _G["ArenaPrepFrame"..i-1]
			f:SetPoint("BOTTOMRIGHT", previous, "TOPRIGHT", 0, cfg.spacing)
		end
		p:ClearAllPoints() 
		p:SetPoint("LEFT", _G["ArenaEnemyFrame"..i], "RIGHT", -4, 0) 
		
		f.SetPoint = function() end -- Set this way so to not be moved again. Otherwise when entering arena blizzard will override the positions
		p.SetPoint = function() end
	end
		
	trinkets = {}
	local arenaFrame, trinket
	for i = 1, 5 do
		arenaFrame = "ArenaEnemyFrame"..i
		trinket = CreateFrame("Cooldown", arenaFrame.."Trinket", ArenaEnemyFrames)
		trinket:SetPoint("TOPRIGHT", arenaFrame, 30, -6)
		trinket:SetSize(24, 24)
		trinket.icon = trinket:CreateTexture(nil, "BACKGROUND")
		trinket.icon:SetAllPoints()
		trinket.icon:SetTexture("Interface\\Icons\\inv_jewelry_trinketpvp_01")
		trinket:Hide()
		trinkets["arena"..i] = trinket
	end

	local events = CreateFrame("Frame")
	function events:UNIT_SPELLCAST_SUCCEEDED(unitID, spell, rank, lineID, spellID)
		if not trinkets[unitID] then return	end
		if spellID == 59752 or spellID == 42292 then
			CooldownFrame_SetTimer(trinkets[unitID], GetTime(), 120, 1)
			SendChatMessage("Trinket used by: "..GetUnitName(unitID, true), "PARTY")
		end
	end

	function events:PLAYER_ENTERING_WORLD()
		local _, instanceType = IsInInstance()
		if instanceType == "arena" then
				self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		elseif self:IsEventRegistered("UNIT_SPELLCAST_SUCCEEDED") then
			self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			for _, trinket in pairs(trinkets) do
				trinket:SetCooldown(0, 0)
				trinket:Hide()
			end
		end
	end
	events:SetScript("OnEvent", function(self, event, ...) return self[event](self, ...) end)
	events:RegisterEvent("PLAYER_ENTERING_WORLD")
	
--Topic macros from: http://us.battle.net/wow/en/forum/topic/10160036139
--[[
-- Show frames
/run LoadAddOn("Blizzard_ArenaUI") for i = 1, 5 do _G["ArenaEnemyFrame"..i]:Show(); _G["ArenaEnemyFrame"..i.."CastingBar"]:Show(); _G["ArenaEnemyFrame"..i.."PetFrame"]:Show() end
	
-- Move frames
/run LoadAddOn("Blizzard_ArenaUI")local s,f="ArenaEnemyFrame"for i=1,5 do f=_G[s..i]f:ClearAllPoints()f:SetScale(1.1)f:SetPoint("TOPLEFT",i==1 and -1325 or _G[s..(i-1)],i==1 and-270 or"BOTTOMLEFT")f:Show()_G[s..i.."CastingBar"]:Show()end _G[s.."s"]:Show()
	
-- Hide frames
/run LoadAddOn("Blizzard_ArenaUI");ArenaEnemyFrames:Hide();ArenaEnemyFrame1:Hide();ArenaEnemyFrame2:Hide();ArenaEnemyFrame3:Hide();ArenaEnemyFrame1CastingBar:Hide()

-- Pets on right of arena frames
/run local s,p="ArenaEnemyFrame" for i=1,3 do p=_G[s..i.."PetFrame"] p:ClearAllPoints() p:SetPoint("LEFT",_G[s..i],"RIGHT",-4,0) p:Show() end

-- Drag able frames
/run local f=ArenaEnemyFrame1; f:SetMovable(true) f:EnableMouse(true) f:SetUserPlaced(true) f:SetScript('onmousedown',f.StartMoving) f:SetScript('onmouseup',f.StopMovingOrSizing)
		
	ArenaEnemyFrame1:ClearAllPoints()
	ArenaEnemyFrame2:ClearAllPoints()
	ArenaEnemyFrame3:ClearAllPoints()
	ArenaEnemyFrame4:ClearAllPoints()
	ArenaEnemyFrame5:ClearAllPoints()

	ArenaEnemyFrame1:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
	ArenaEnemyFrame2:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y+50)
	ArenaEnemyFrame3:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y+100)
	ArenaEnemyFrame4:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y+150)
	ArenaEnemyFrame5:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y+200)

	ArenaEnemyFrame1.SetPoint = function() end
	ArenaEnemyFrame2.SetPoint = function() end
	ArenaEnemyFrame3.SetPoint = function() end
	ArenaEnemyFrame4.SetPoint = function() end
	ArenaEnemyFrame5.SetPoint = function() end

--]]
	