	
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.target
	
	local function Target_Update()
		TargetFrame:ClearAllPoints()
		TargetFrame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		TargetFrame:SetScale(cfg.scale)
		if cfg.combat.show then
			TargetFrame:SetAlpha(cfg.combat.fadeOut)
		else
			TargetFrame:SetAlpha(1)
		end
		TargetFrame:SetUserPlaced(true) -- Entering Vehicle no longer moves the frame 
	end
	local f = CreateFrame("Frame", nil, UIParent)
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:SetScript("OnEvent", Target_Update)
	
	if cfg.combat.show then
		local function TargetIn_Update()
			TargetFrame:SetAlpha(cfg.combat.fadeIn)
		end
		local f = CreateFrame("Frame", nil, UIParent)
		f:RegisterEvent("PLAYER_REGEN_DISABLED")
		f:SetScript("OnEvent", TargetIn_Update)	
	end
	
	-----------------------------
	-- ClassColored
	-----------------------------	
	if not cfg.classcolored.enable then return end
	local frame = CreateFrame("FRAME")
	frame:RegisterEvent("GROUP_ROSTER_UPDATE")
	frame:RegisterEvent("PLAYER_TARGET_CHANGED")
	frame:RegisterEvent("PLAYER_FOCUS_CHANGED")
	frame:RegisterEvent("UNIT_FACTION")

	local function eventHandler(self, event, ...)
		if UnitIsPlayer("target") then
			c = RAID_CLASS_COLORS[select(2, UnitClass("target"))]
			TargetFrameNameBackground:SetVertexColor(c.r, c.g, c.b)
		end
	end

	frame:SetScript("OnEvent", eventHandler)

	for _, BarTextures in pairs({TargetFrameNameBackground, FocusFrameNameBackground}) do
		BarTextures:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
	end
	
	-----------------------------
	-- CastBar
	-----------------------------
	local cfg = gcfg.units.target.castbar
	if cfg.enable then
		local cfg = gcfg.units.target.castbar.onTop
		if cfg.enable then
			TargetFrameSpellBar:ClearAllPoints()
			TargetFrameSpellBar:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
			TargetFrameSpellBar.SetPoint = function() end
			TargetFrameSpellBar:SetScale(cfg.scale)
		end
		
		local cfg = gcfg.units.target.castbar.detach
		if cfg.enable then
			TargetFrameSpellBar:ClearAllPoints()
			TargetFrameSpellBar:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
			TargetFrameSpellBar.SetPoint = function() end
			TargetFrameSpellBar:SetScale(cfg.scale)
		end
	else
		TargetFrameSpellBar:UnregisterAllEvents()
	end